%% Výpočet průběhu koeficientů cL a cD z průběhu rychlostní poláry
clear all;clc;
%% Parametry
ofset = 2;
rozsah_speedu = 8;
rozsah_rizeni = 25;
alpha = 0:0.1:(ofset+rozsah_speedu+rozsah_rizeni);

%% Body k proložení cftoolem
% vd = [6.3 10 14];
% vo = [-2 -1.1 -2.5];
% 
% cftool

%% Výsledek z cftoolu
x = 6.3:0.1:14; % vd
p1 =    -0.07704;
p2 =       1.499;
p3 =      -8.386;
f = p1.*x.^2 + p2.*x + p3;

% % kontrolní tisk poláry
% plot(x,f,0,0,'.'); grid;axis equal;
% xlabel('v_D [m/s]');
% ylabel('v_O [m/s]');
% title('Rychlostní polára');
% figure

%% Získání závislosti [vo vd] = f(alpha)
% část speedová
j = 1;
for i=1:length(x) % ridici velicina je x (vd)
    if (x(i)>=10)
        v_Ds(j) = x(i);
        v_Os(j) = f(i);
        j=j+1;
    end;
end;
% dopočteme alpha
alpha_speed = linspace((ofset+rozsah_speedu),ofset,length(v_Ds));

% část brzdová
j = 1;
for i=1:length(x) % ridici velicina je x (vd)
    if (x(i)<=10)
        v_Db(j) = x(i);
        v_Ob(j) = f(i);
        j=j+1;
    end;
end;
% dopočteme alpha
alpha_brzdy = linspace((ofset+rozsah_speedu+rozsah_rizeni),ofset+rozsah_speedu,length(v_Db));

% složíme dohromady
alpha = [alpha_brzdy alpha_speed];
v_D = [v_Db v_Ds];
v_O = [v_Ob v_Os];
%% Výpočet koeficientů cL a cD
Fg = 80*9.81;
cl = zeros(length(alpha),1);
cd = zeros(length(alpha),1);
for i = 1:length(alpha)
    vd = v_D(i);
    vo = v_O(i);
    v = sqrt(vd^2 + vo^2);
    alph = alpha(i);
    gama = abs(asin(vo/v));
    
    % do alfy přičteme gama, protože do teď byla alfa jenom delta
    alpha(i) = alpha(i)+rad2deg(gama);
    
    % odpor pilota v sedačce
    Fo = -0.21*v^2;
    
    D = Fg / (cos(gama)^2/sin(gama)+sin(gama)) - Fo;
    L = (D+Fo)*cos(gama)/sin(gama);
    
    % uložíme koeficienty
    cl(i) = L/v^2;
    cd(i) = D/v^2;
end;

%% Doplnění výsledků pro celých 360° - odhady
alpha = [360 315 270 225 180 135 90 alpha(1)];
cl    = [3  ; 2; 1.5; 1.25; 1.25; 1.5; 2; cl(1)];
cd    = [0.7;   4;12;  4;  2;   4;12; cd; 0.7];

% alpha = [ alpha(end) 3];
% cl    = [cl(end);  0.7 ];

%% Tisk výsledků

subplot(2,1,1);
plot(alpha,cl,'*-g');
grid;
title('c_L');
xlabel('alpha [°]');
ylabel('c_L [1]');
subplot(2,1,2);
plot(alpha,cd,'*-g');
grid;
title('c_D');
xlabel('alpha [°]');
ylabel('c_D [1]');

%% Výsledky cftoolu

